/***********************************************************************
 * Ursache Andrei                                                      *
 * Grupa 332CA                                                         *
 * Seria CA                                                            *
 * Facultatea de Automatica si Calculatoare                            *
 * UPB                                                                 *
 ***********************************************************************/
 
#include <stdio.h>
#include "usart.h"
#include <avr/interrupt.h>

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

/* 1 - masina e ridicata in fata, 0 - caz contrar */
int up=0;

void run(void) {

	USART0_init();
	
	/* Setez pinul PD6 - buton ca intrare. */
	DDRD &= ~(1 << PD6);
	/* Activez rezistenta de pull-up pentru pinul PD6. */
	PORTD |= (1 << PD6);

	/* Setez pinul PD7 - led ca iesire. */
	DDRD |= (1 << PD7);
	/* Sting LED-ul. */
	PORTD &= ~(1 << PD7);
	
	
	/* Setez motor tractiune */
	DDRD |= (1 << PD2); // PWM
	PORTD |= (1 << PD2);
	DDRD |= (1 << PD3); // S1
	PORTD &= ~(1 << PD3);
	DDRD |= (1 << PD4); // S2
	PORTD &= ~(1 << PD4);
	
	/* Setez motor fata */
	DDRB |= (1 << PB0); // PWM
	PORTB |= (1 << PB0);
	DDRB |= (1 << PB1); // S1
	PORTB &= ~(1 << PB1);
	DDRB |= (1 << PB2); // S2
	PORTB &= ~(1 << PB2);
	
	/* Setez motor viraj */
	DDRB |= (1 << PB3); // S1
	PORTB &= ~(1 << PB3);
	DDRB |= (1 << PB4); // S2
	PORTB &= ~(1 << PB4);

	/* Till death do us part */
	while (1) {
		
		/* Primeste comanda prin seriala-bluetooth */
		char c = USART0_receive(); 
		
		switch(c) {
		
			case 'w': // Inainte
				PORTD |= (1 << PD7); // led
				
				/* Activeaza motor tractiune */
				PORTD &= ~(1 << PD3);
				_delay_ms(100);
				PORTD |= (1 << PD4);
				break;
				
			case 's': // Inapoi
				PORTD |= (1 << PD7); // led
				
				/* Activeaza motor tractiune */
				PORTD &= ~(1 << PD4);
				_delay_ms(100);
				PORTD |= (1 << PD3);
				break;
				
			case 'p': // ridica
				PORTD |= (1 << PD7);
				
				PORTB &= ~(1 << PB1); // ridica fata
				PORTB |= (1 << PB2);
				
				_delay_ms(210);
				
				PORTB &= ~(1 << PB1); // opreste motor
				PORTB &= ~(1 << PB2);
				
				PORTD &= ~(1 << PD7);
				up = 1;
				break;
			
			case 'l': // coboara
				PORTD |= (1 << PD7);
				
				PORTB &= ~(1 << PB2); // coboara fata
				PORTB |= (1 << PB1);
				
				_delay_ms(90);
				
				PORTB &= ~(1 << PB1); // opreste motor
				PORTB &= ~(1 << PB2);
				
				PORTD &= ~(1 << PD7);
				up = 0;
				break;
				
			case 'a': // stanga
				PORTB &= ~(1 << PB3); // vireaza stanga
				PORTB |= (1 << PB4);
				
				_delay_ms(50);
				
				if(!up){ // daca nu e ridicata in fata fortat, ridica
					PORTB &= ~(1 << PB1); // ridica
					PORTB |= (1 << PB2);
					_delay_ms(210);
					PORTB &= ~(1 << PB1);
					PORTB &= ~(1 << PB2);
				}
				break;
				
			case 'd': // dreapta
				PORTB &= ~(1 << PB4); // vireaza dreapta
				PORTB |= (1 << PB3);
				
				_delay_ms(50);
				
				if(!up){
					PORTB &= ~(1 << PB1); // daca nu e ridicata in fata fortat, ridica
					PORTB |= (1 << PB2);
					_delay_ms(210);
					PORTB &= ~(1 << PB1);
					PORTB &= ~(1 << PB2);
				}
				break;
				
			case 'z': // opreste stanga
				
				PORTB &= ~(1 << PB4); // return to zero
				_delay_ms(10);
				PORTB |= (1 << PB3);
				_delay_ms(50);
				PORTB &= ~(1 << PB3);
				PORTB &= ~(1 << PB4);
				
				if(!up){ // daca nu e ridicata in fata fortat
					PORTB &= ~(1 << PB2); // coboara
					PORTB |= (1 << PB1);
					_delay_ms(90);
					PORTB &= ~(1 << PB1);
					PORTB &= ~(1 << PB2);
				}
				break;
			
			case 'c': // opreste dreapta
				PORTB &= ~(1 << PB3); // return to zero
				_delay_ms(10);
				PORTB |= (1 << PB4);
				_delay_ms(50);
				PORTB &= ~(1 << PB3);
				PORTB &= ~(1 << PB4);
				
				if(!up){ // daca nu e ridicata in fata fortat
					PORTB &= ~(1 << PB2); // coboara
					PORTB |= (1 << PB1);
					_delay_ms(90);
					PORTB &= ~(1 << PB1);
					PORTB &= ~(1 << PB2);
				}
				break;
		
				
			default: // NOP
				PORTD &= ~(1 << PD7); // bec
			
				PORTD &= ~(1 << PD3); // oprire motor tractiune
				PORTD &= ~(1 << PD4);
		}
	}
}

int main(void) {
	
	run();

	return 0;
}
